/* lockfile.h from iplog v1.2 -- eric@ojnk.nu */
#include <stdlib.h>
#include <malloc.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <paths.h>
#include <errno.h>
extern int errno;

#ifndef _PATH_VARRUN
#	define	_PATH_VARRUN	"/var/run/"
#endif

char *my_getpid(void) {
	static char pid[10];

	sprintf(pid, "%d\n", getpid());
	return (pid);
}

void initialize_lockfile(char *p) {
	struct stat st;
	char *name, buf[8];
	int fd = 0, pid = 0;

	name = (char *)malloc(strlen(_PATH_VARRUN) + strlen(p) + 5);

	if (name == NULL)
		fatal("lockfile: malloc: %m");

	sprintf(name, "%s%s.pid", _PATH_VARRUN, p);

	if (lstat(name, &st) != (-1L)) {
		if (S_ISREG(st.st_mode)) {
			if ((fd = open(name, O_RDONLY)) != (-1L)) {
				if (read(fd, buf, 8) > 0)
					sscanf(buf, "%d\n", &pid);

				if (kill(pid, 0) && (errno == ESRCH)) {
					if (unlink(name) != (-1L))
						(void)close(fd);
					else
						fatal("couldn't remove stale lockfile %s", name);
				} else if (flock(fd, LOCK_EX|LOCK_NB) == (-1L))
					fatal("%s is already running (pid: %d)", p, pid);	
			}
		} else
			fatal("lockfile %s isn't a regular file", name);
	}

	if ((fd = open(name, O_RDWR|O_CREAT|O_TRUNC, 0644)) != (-1L)) {
		write(fd, my_getpid(), strlen(my_getpid()));

		if (flock(fd, LOCK_EX|LOCK_NB) != (-1L))
			free(name);
		else
			fatal("lockfile not initialized (%m)");
	}

	return;
}
